C++刷leetcode(452. 用最少数量的箭引爆气球)【贪心算法】
本帖最后由 糖逗 于 2020-4-20 12:40 编辑题目描述:
在二维空间中有许多球形的气球。对于每个气球,提供的输入是水平方向上,气球直径的开始和结束坐标。由于它是水平的,所以y坐标并不重要,因此只要知道开始和结束的x坐标就足够了。开始坐标总是小于结束坐标。平面内最多存在104个气球。
一支弓箭可以沿着x轴从不同点完全垂直地射出。在坐标x处射出一支箭,若有一个气球的直径的开始和结束坐标为 xstart,xend, 且满足 xstart ≤ x ≤ xend,则该气球会被引爆。可以射出的弓箭的数量没有限制。 弓箭一旦被射出之后,可以无限地前进。我们想找到使得所有气球全部被引爆,所需的弓箭的最小数量。
Example:
输入:
[, , , ]
输出:
2
解释:
对于该样例,我们可以在x = 6(射爆,两个气球)和 x = 11(射爆另外两个气球)。
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/minimum-number-of-arrows-to-burst-balloons
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
int solution(vector<int>& input) {
if(input.empty()) return 0;
sort(input.begin(), input.end());
int len = input.size();
int count = 0;
int right = input;
for(int i = 1; i < len; i++){
if(input <= right){
count++;
right = min(input, right);
}
else right = input;
}
return len - count;
}
int main(void){
vector<int> input1
int number;
while(cin >> number){
input1.push_back(number);
}
cout << solution(input1) << endl;
return 0;
}
参考链接:https://leetcode-cn.com/problems/minimum-number-of-arrows-to-burst-balloons/solution/si-lu-qing-xi-ming-liao-jian-ji-de-c-by-lu-guo-de-/
贪心算法好考验智商呀,可惜智商不够{:10_266:}
页:
[1]